/*
    Copyright (C) 2005 - 2009 Manuel Lausch

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Manuel Lausch
    Salierstr. 52
    75177 Pfohrzheim
    GERMANY
    software@manuellausch.de
*/

#include "config-player.h"
#include "definitions.h"
#include <iostream>
#include <iomanip>

config_player::config_player()
{
}

void config_player::set(int speed, unsigned int color, int up, int down, int left, int right)
{
	playerspeed = speed;
	playercolor = color;
	key_left = left;
	key_right = right;
	key_up = up;
	key_down = down;
}

int config_player::get_playerspeed()
{
	return playerspeed;
}

int config_player::get_playercolor()
{
	return playercolor;
}

int config_player::get_key(direction value)
{
	switch(value)
	{
		case left:	return key_left; break;
		case right:	return key_right; break;
		case up:	return key_up;	break;
		case down:	return key_down;	break;
		default: break; //Fall sollte nicht eintreffen
	}
	return 0;
}

std::ostream& operator<<(std::ostream& os, config_player& mc)
{
	int key, i;
	os << std::showbase << std::internal;
	os << mc.get_playerspeed() << " " << std::hex << std::setw( 10 ) << std::setfill('0') << mc.get_playercolor() << std::dec << " ";


	for(i = up; i <= right; i++)
	{
		key = mc.get_key((direction)i);
		if(key < 32 || key > 127)
			os << key << " ";
		else
			os << "'" << (char)key << "'" << " ";
	}

	return os;
}
