/*
    Copyright (C) 2005 - 2009 Manuel Lausch

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Manuel Lausch
    Salierstr. 52
    75177 Pforzheim
    GERMANY
    software@manuellausch.de
*/


// Diese Klasse verwaltet die Configuration diverser eigenschaften. Diese knnen Spter
// auch per config_datei eingelesen werden und/oder dynamisch im betrieb gendert werden

#ifndef CONFIG_H
#define CONFIG_H

#include <string>
#include "config-player.h"

class config
{
public:
	config();
	~config();
	const unsigned int get_feldbreite() const; //const fr den Rckgabetyp entfernen (gcc 4 ungrad warnt)
	const unsigned int get_feldhohe() const;
	const unsigned int get_feldgrose() const;
	const std::string & get_datapath() const; 
	const unsigned int get_quadsize() const;
	const std::string & get_version() const;
	const unsigned int get_maxplayer() const;
	config_player *get_player(int);  // Variablenname
	std::string get_filepath(std::string);
	void save(); // hier const
	void load();


	void set_datapath(std::string); // parameter als const referenz

private:
	unsigned int feldbreite;
	unsigned int feldhohe;
	unsigned int quadsize;
	unsigned int maxplayer;
	config_player *player;  // ist ein array

	std::string datapath;
	std::string version;
};

#endif
