/*
    Copyright (C) 2005 - 2008 Manuel Lausch

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Manuel Lausch
    Salierstr. 52
    75177 Pfohrzheim
    GERMANY
    software@manuellausch.de
*/

#ifndef PLAYGROUND_H
#define PLAYGROUND_H

#include <SDL.h>
#include "config.h"
#include "definitions.h"


class playground
{
public:
	playground(SDL_Surface*, config*);
	playground(SDL_Surface*, char*, config*);
	~playground();

	void set_field(short int, short int, field, Uint32, form=block);
	void del_field(short int, short int);
	field get_field(short int, short int);

private:
	void rgbsplit(Uint32, Uint8&, Uint8&, Uint8&);
	void initparts();


	field *grid;
	SDL_Surface* pDisplay;
	SDL_Surface *pCircle, *pBlock, *pSolid, *pPartX, *pPartY, *pEdge1, *pEdge2, *pEdge3, *pEdge4, *pStart1, *pStart2, *pStart3, *pStart4;
	config *konfiguration;
};

#endif
