/*
    Copyright (C) 2005 - 2009 Manuel Lausch

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Manuel Lausch
    Salierstr. 52
    75177 Pforzheim
    GERMANY
    software@manuellausch.de
*/

#include <iostream>
#include <string>
#include <SDL.h>
#include <SDL_gfxPrimitives.h>
#include <SDL_ttf.h>
#include "snake.h"
#include "config.h"
#include "definitions.h" // klingt auch so als obs ins config msste
#include "koordinate.h"
#include "playground.h"
#include "queue_key.h"


// using std::queue;
using std::string;
bool snake::pause = false;

unsigned int snake::food = 0;

snake::snake(SDL_Surface *pD, playground *pP,config *konfiguration)
{
	// Font fr Textausgabe laden
	// Diese Zeilen sollten Hier aber raus, und in eine extra textausgabe klasse oder so
	// eingebaut werden.
	pFont = TTF_OpenFont(konfiguration->get_filepath("Vera.ttf").c_str(), 20);
	if (pFont == NULL)
	{
		std::cerr << "Font konnte nicht geffnet werden\n" ;
	}

	pDisplay = pD;
	pPlayground = pP;
	this->konfiguration = konfiguration;

	int tt = rand() % konfiguration->get_feldbreite(); // Zufllige spalte fr schlangenanfang

	// initial position of snake
	// ahm, die farbe ist da irgendwie so hart reinkodiert... naja, was solls
	color = 0x0000ffff;
	speed = 50;

	pPlayground->set_field(tt, 1, f_snake, color);
	pPlayground->set_field(tt, 2, f_snake, color);

	punkte = 0;

	x = tt;
	y = 2;
	default_direction = down;

	koordinate temp;
	temp.x = tt;
	temp.y = 1;
	snake_queue.push(temp);
	temp.y = 2;
	snake_queue.push(temp);

	if(food == 0)
		generate_food();

	my_number = ++food; //puhhh, ab der stelle hat food nix mehr mit dem futter zu tun,
	//sondern mit der position der textausgabe der punkte.....

}

snake::~snake()
{
	/* Nette Spielerei, aber dafr fehlt irgendwie ne passendere ifrastrucktur ;)
	for (int i=0; i < punkte+2; i++)
	{
		SDL_mutexP(pMut);
		pPlayground->del_field(snake_queue.front().x, snake_queue.front().y);
		snake_queue.pop();
		SDL_mutexV(pMut);
		SDL_Delay(1000);
	}
	*/
}

int snake::step()
{
	if(!pause)
	{
		direction way = ways.get();
		form design = block;

		if (default_direction == right	&& way == down)	design = edge1;
		if (default_direction == up	&& way == left)	design = edge1;

		if (default_direction == right	&& way == up)	design = edge2;
		if (default_direction == down	&& way == left)	design = edge2;

		if (default_direction == down	&& way == right)	design = edge3;
		if (default_direction == left	&& way == up)	design = edge3;

		if (default_direction == up	&& way == right)	design = edge4;
		if (default_direction == left	&& way == down)	design = edge4;

		if ((default_direction == right || default_direction == left) && (way == right || way == left || way == old)) design = partX;
		if ((default_direction == up || default_direction == down) && (way == up || way == down || way == old)) design = partY;

		pPlayground->set_field(x, y, f_snake, get_color(), design);

		if ((way == down && default_direction != up) || (way == right && default_direction != left) || (way == up && default_direction != down) || (way == left && default_direction != right))
			default_direction = way;

		switch (default_direction)
		{
		case up:
			if (0 == y) y = konfiguration->get_feldhohe();
			y--;
			design = begin1;
			break;

		case right:
			x++;
			if (x == konfiguration->get_feldbreite()) x = 0;
			design = begin2;
			break;

		case down:
			y++;
			if (y == konfiguration->get_feldhohe()) y = 0;
			design = begin3;
			break;

		case left:
			if (0 == x) x = konfiguration->get_feldbreite();
			x--;
			design = begin4;
			break;
		}


		if(pPlayground->get_field(x, y) == f_food)
		{
			generate_food();
	//		generate_food();
			SDL_Event event;
			SDL_UserEvent uevent;
			uevent.type = SDL_USEREVENT;
			uevent.code = 'p';
			uevent.data1 = uevent.data2 = NULL; // Um warnungen im GCC4 zu vermeiden. Diese Strukturvariablen werden derzeit nmlich noch nicht bentigt.
			event.user = uevent;
			SDL_PushEvent(&event);

			punkte++;
			{
				SDL_Rect drect;
				SDL_Surface *font_src = 0;
				char titel[256];
				sprintf(titel, "Punkte: %d", punkte);
				SDL_Color color = {255,255,255};
				font_src = TTF_RenderText_Solid(pFont, titel, color);  // hat irgendwie ein bug
				// font_src = TTF_RenderText_Blended(pFont, titel, color);  // drum den workaround
				if (font_src == 0)
				{
					std::cerr << "Fehler beim Textrendering ---> Text wird nicht ausgegeben. -- " << SDL_GetError() << TTF_GetError() << "\n";
					// exit(-1); // muss angepasst werden wegen den threads..
				}
				else
				{
					drect.x = (my_number - 1) * 120 + 20;
					drect.y = konfiguration->get_feldhohe() * konfiguration->get_quadsize() + 10;
					drect.w = font_src->w;
					drect.h = font_src->h;
					boxColor(pDisplay, drect.x, drect.y, drect.x+drect.w, drect.y+drect.h, 0x000000ff);
					SDL_BlitSurface(font_src, NULL, pDisplay, &drect);
					SDL_Flip(pDisplay);
				}
			}
		}
		else
		{
			pPlayground->del_field(snake_queue.front().x, snake_queue.front().y);
			snake_queue.pop();
		}

		koordinate temp;
		temp.x = x;
		temp.y = y;
		snake_queue.push(temp);


		if(pPlayground->get_field(x, y) == f_wall || pPlayground->get_field(x, y) == f_snake)
		{
			SDL_Event event;
			SDL_UserEvent uevent;
			uevent.type = SDL_USEREVENT;
			uevent.code = 'c';
			uevent.data1 = uevent.data2 = NULL; // Um warnungen in GCC4 zu vermeiden
			event.user = uevent;
			SDL_PushEvent(&event);

			return 1;
		}
		else
		{
			pPlayground->set_field(x, y, f_snake, get_color(), design);
			return 0;
		}
	}
	return 0;
}

void snake::generate_food()
{
	srand(time(0));
	unsigned short int px, py;

	do
	{
		px = (unsigned short int) (rand() % konfiguration->get_feldbreite());
		py = (unsigned short int) (rand() % konfiguration->get_feldhohe());
	} while (pPlayground->get_field(px, py) != f_empty);

	pPlayground->set_field(px, py, f_food, 0x00ff00ff);
}


Uint32 snake::step_timer(Uint32 intervall, void *parameter)
{
	snake * player = (snake*) parameter;
	int status;
	status = player->step();
	if(status == 0)
		return intervall;
	else
		return 0;
}

unsigned short int snake::get_speed()
{
	return speed;
}

void snake::set_speed(unsigned short int arg)
{
	speed = arg;
}

Uint32 snake::get_color()
{
	return color;
}

void snake::set_color(Uint32 arg)
{
	color = arg;
}





