/*
    Copyright (C) 2005 - 2009 Manuel Lausch

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Manuel Lausch
    Salierstr. 52
    75177 Pfohrzheim
    GERMANY
    software@manuellausch.de
*/
#ifndef SNAKE_H
#define SNAKE_H

#include <SDL_ttf.h>
#include <string>
#include "definitions.h"
#include "koordinate.h"
#include "playground.h"
#include "queue_key.h"
#include <queue>
#include "config.h"



class snake
{
protected:
	SDL_Surface *pDisplay;
	TTF_Font *pFont;
	playground *pPlayground;
	SDL_mutex *pMut;
	config *konfiguration;
	unsigned int x, y;
	std::queue<koordinate> snake_queue;
	unsigned int punkte;
	unsigned int default_direction;
	unsigned int speed;
	Uint32 color;
	unsigned int my_number; // was war das gleich nochmal ?!

	static unsigned int food;

	void generate_food();
	unsigned short int get_speed();
	Uint32 get_color();


public:
	queue_key ways;
	static bool pause;

	snake(SDL_Surface*, playground*, config*);
	~snake();
	int step();
	static Uint32 step_timer(Uint32, void*);
	void set_speed(unsigned short int);
	void set_color(Uint32);
};

#endif
